aboutsummaryrefslogtreecommitdiff
path: root/tests/test_files.sh
diff options
context:
space:
mode:
authorLasse Collin <lasse.collin@tukaani.org>2022-10-19 19:39:35 +0300
committerLasse Collin <lasse.collin@tukaani.org>2022-10-19 19:39:35 +0300
commit424ac91c7e0419393ff2bde4f62e21fa611c776d (patch)
tree38816b3dbc0ffdfbcc44e903f0ce591ad5a8d61e /tests/test_files.sh
parentTest: Remove the (exit 1) lines. (diff)
downloadxz-424ac91c7e0419393ff2bde4f62e21fa611c776d.tar.xz
Tests: Skip tests in test_*.sh if encoders and/or decoders are disabled.
This isn't perfect as the scripts can still fail if only certain filters are disabled. This is still an improvement as now "make check" has better behavior when all encoders or decoders are disabled. Grepping ../config.h is simple and fairly clean but it only works if config.h was created. CMake builds don't create config.h but they don't use these test scripts either. Thanks to Sebastian Andrzej Siewior for reporting the problem. Thanks to Jia Tan for the original patch which grepped xz error messages instead of config.h.
Diffstat (limited to 'tests/test_files.sh')
-rwxr-xr-xtests/test_files.sh11
1 files changed, 11 insertions, 0 deletions
diff --git a/tests/test_files.sh b/tests/test_files.sh
index d770e2b6..17c542f5 100755
--- a/tests/test_files.sh
+++ b/tests/test_files.sh
@@ -18,6 +18,17 @@ if test -z "$XZ$XZDEC"; then
exit 77
fi
+# If decompression support is missing, this test is skipped.
+# This isn't perfect as if only some decompressors are disabled
+# then some good files might not decompress and the test fails
+# for a (kind of) wrong reason.
+if grep 'define HAVE_DECODERS' ../config.h > /dev/null ; then
+ :
+else
+ echo "Decompression support is disabled, skipping this test."
+ exit 77
+fi
+
for I in "$srcdir"/files/good-*.xz
do
if test -z "$XZ" || "$XZ" -dc "$I" > /dev/null; then